const questionRouter = require('express').Router();
let Question = require('../models/question.model');
const mongoose = require('mongoose');

questionRouter.route('/').get(function(req, res) {
    Question.find(function(err, questions) {
        if (err) {
            console.log(err);
            res.render('index');
        } else {
            res.json(questions);
        }
    });
});

questionRouter.route('/:id').get(function (req, res) {
    let id = req.params.id;
    Question.findById(id, function (err, question) {
        res.json(question);
    });
});

questionRouter.route('/questionId/:id').get(function (req, res) {
    console.log("Question ID");
    console.log(req.params.id);
    let id = req.params.id;
    Question.find({"_id" : id}, function (err, question) {
        res.json(question);
    });
});

questionRouter.route('/add').post(function(req, res) {
    const question = new Question({
        question_id: new mongoose.Types.ObjectId(),
        category : req.body.category,
        name : req.body.name,
        question_text:  req.body.question_text,
        question_answer:req.body.question_answer,
        defult_mark:  req.body.defult_mark,
        q_type:  req.body.q_type,
        time_createdby:  req.body.time_createdby,
        time_modifiedby: req.body.time_modifiedby,
        general_feedback: req.body.general_feedback
    });
    question
        .save()
        .then(result => {
            res.json(result);
            console.log(result);
            res.status(201).json({
                message: "Created product successfully",
                createdProduct: {
                    category:  result.category,
                    name: result.name,
                    question_text:  result.question_text,
                    defult_mark:  result.defult_mark,
                    q_type:  result.q_type,
                    time_createdby:  req.body.time_createdby,
                    time_modifiedby:  req.body.time_modifiedby,
                    general_feedback: req.body.general_feedback,
                    question_id: result.question_id,
                    request: {
                        type: 'GET',
                        url: "http://localhost:5000/questions/" + result._id
                    }
                }
            });
        })
        .catch(err => {
            console.log(err);
            res.status(500).json({error: err});
        });
});

questionRouter.route('/update/:id').post((req, res) => {
    Question.findById(req.params.id,function(err, question){
        if(!question)
            req.status(404).send("data is not found");
        else {
            question.category = req.body.category;
            question.name = req.body.name;
            question.question_text = req.body.question_text;
            question.question_answer = req.body.question_answer;
            question.defult_mark = req.body.defult_mark;
            question.q_type = req.body.q_type;
            question.time_modifiedby = req.body.time_modifiedby;
            question.general_feedback = req.body.general_feedback;

        }
        question.save().then(question =>{
            res.json('Item update!');
        })
            .catch(err =>{
                res.status(400).send("Update not possible");
            });
    });
});



questionRouter.route('/delete/:id').delete((req, res) => {
    Question.findByIdAndDelete(req.params.id)
        .then(() => res.json('Product Deleted.'))
        .catch(err => res.status(400).json('Error: ' + err));
});

module.exports = questionRouter;