import React, { Component } from 'react';
import axios from 'axios';
import { Link } from "react-router-dom";
import swal from 'sweetalert';

const Quantity = props => (

    <tr>
        {/*<td>{props.quantity.item_id}</td>*/}
        <td>{props.quantity.question_text}</td>
        <td>{props.quantity.question_answer}</td>
        <td>{props.quantity.time_modifiedby}</td>
        <td>
            <div>
            <Link className="mx-1 text-success fas fa-pen text-decoration-none" to={"/edititem/"+props.quantity._id}></Link>  <span className=" mx-1 text-danger fas fa-trash" href='#' onClick={()=>{props.deleteProduct(props.quantity._id)}} ></span>
            </div>
        </td>
    </tr>
);


export default class QuestionBankUI extends Component {

    constructor(props) {
        super(props);
        this.onChangeQType = this.onChangeQType.bind(this);
        this.deleteProduct = this.deleteProduct.bind(this);
        this.onSubmit = this.onSubmit.bind(this);

        this.state = {
            q_type: '',
            quantity: []
        }
    }

    quantityList() {
        return this.state.quantity.map(currentTodo => {
            return <Quantity quantity={currentTodo} deleteProduct={this.deleteProduct} key={currentTodo._id} />
        });
    }

    componentDidUpdate() {

        axios.get('http://localhost:5000/questions/')
            .then(response => {
                this.setState({ quantity: response.data });
            })
            .catch(function (error) {
                console.log(error);
            })


    }

    componentDidMount() {

        axios.get('http://localhost:5000/questions/')
            .then(response => {
                this.setState({ quantity: response.data });
            })
            .catch(function (error) {
                console.log(error);
            })


    }

    onChangeQType(e) {
        this.setState({
            q_type: e.target.value
        });
    }

    onSubmit(e) {
        e.preventDefault();

        console.log(`Question type: ${this.state.q_type}`);

        if (this.state.q_type == "Multiple_choice") {
            window.location = '/questionmanagement/';
        } else {

        }
        //window.location = '/admin/pcategory';
    }

    deleteProduct(pid){
        axios.delete('http://localhost:5000/questions/delete/'+pid)
        .then(res => console.log(res.data));
    this.setState({
        quantity:this.state.quantity.filter(el => el.pid !==pid)
    });
    }

    render() {
        return (
            <div className="container text-left">
                <div className="col-sm-10" >
                  
                    <h4> Business Studies</h4>
                    <h6>Dashboard/My courses/Business Studies/Question bank/Questions</h6>

                    <hr />
                </div>
                <form onSubmit={this.onSubmit}>
                <div className="col-sm-10" >
                    <div className="row" >

                        <div className="col-sm-1 mt-1"><label>Category: </label>
                        </div>
                        <div className="col-sm-5">


                            <div style={{ padding: '0px' }}>
                                <select style={{ width: '100%' }} className="browser-default custom-select"
                                    onChange={(e) => this.onChangeQType(e)}>
                                    <option>Select Question Type</option>
                                    <option key="Multiple_choice" value="Multiple_choice">Multiple choice</option>
                                    <option key="True_False" value="True_False">True/False</option>)
                                        </select>
                            </div>
                        </div>

                        <div className="col-sm-3">
                            <button className="btn btn-block btn btn-secondary" type="submit" value="Submit" style={{ color: "white" }}>Create new Question</button>



                        </div>

                        <div className="col-sm-3">
                            <button className="btn btn-block btn btn-info" type="submit" value="Submit" style={{ color: "white" }}>Auto Genarate Question</button>



                        </div>
                    </div></div>
                </form>


<br/>
             
                <div className="col-sm-10">
                <table className="table" >
                    <thead>
                        <tr>
                            <th><h6>Question Text</h6></th>
                            <th><h6>Question Answer</h6></th>
                            <th><h6>Last modified by</h6></th>
                            <th className="col-sm-1"><h6>Action </h6></th>
                        </tr>
                    </thead>
                    <tbody>
                        {this.quantityList()}
                    </tbody>
                </table>
                </div>
            </div>
        )
    }
}